#!/usr/bin/python3

import os
import re
import subprocess
import sys
unoptimized_spv = sys.argv[1]
optimized_spv = unoptimized_spv + ".opt.spv"
cmd = [ "spirv-opt", unoptimized_spv, "-o", optimized_spv, '--convert-local-access-chains', '--eliminate-local-single-store', '--eliminate-local-single-store', '--eliminate-dead-code-aggressive', '--copy-propagate-arrays', '--inline-entry-points-exhaustive', '--if-conversion', '--eliminate-local-single-store', '--scalar-replacement=100', '--inline-entry-points-exhaustive', '--private-to-local', '--ccp', '--eliminate-dead-branches', '--private-to-local', '--vector-dce', '--scalar-replacement=100', '--merge-blocks', '--eliminate-dead-branches', '--eliminate-dead-branches', '--merge-return', '--scalar-replacement=100', '--simplify-instructions', '--merge-blocks', '--private-to-local', '--inline-entry-points-exhaustive', '--eliminate-local-single-block']
result = subprocess.run(cmd)
if result.returncode != 0:
  print("Not interesting: spirv-opt failed on the shader.")
  sys.exit(1)
cmd = [ "spirv-val", optimized_spv ]
result = subprocess.run(cmd, stderr=subprocess.PIPE)
if result.returncode == 0:
  print("Not interesting: spirv-val succeeded.")
  sys.exit(1)
abstracted_error_string = re.sub('\d+', '_', str(result.stderr, 'utf-8').split("\n")[0])
if abstracted_error_string != "error: line _: The continue construct with the continue target _[%_] is not post dominated by the back-edge block _[%_]":
  print("Not interesting: error output '" + abstracted_error_string + "' did not match 'error: line _: The continue construct with the continue target _[%_] is not post dominated by the back-edge block _[%_]'")
  sys.exit(1)
print("Interesting!")
sys.exit(0)
